

// This C++ file was created by SanEditor

#include "Atomic/Initializer/InitializerSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         InitializerSAN Constructor             
******************************************************************/


InitializerSAN::InitializerSAN(){


  Activity* InitialActionList[1]={
    &IA_Create_Clients_MW_Servers  // 0
  };

  BaseGroupClass* InitialGroupList[1]={
    (BaseGroupClass*) &(IA_Create_Clients_MW_Servers)
  };

  Start = new Place("Start" ,1);
  Start_Clients_and_Servers = new Place("Start_Clients_and_Servers" ,0);
  Client_Trans_IDs = new Place("Client_Trans_IDs" ,GV_Number_of_Clients_and_Trans);
  Init_Blocking_Pointers = new Place("Init_Blocking_Pointers" ,GV_Number_of_Clients_and_Trans);
  BaseStateVariableClass* InitialPlaces[4]={
    Start,  // 0
    Start_Clients_and_Servers,  // 1
    Client_Trans_IDs,  // 2
    Init_Blocking_Pointers   // 3
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("Initializer", 4, InitialPlaces, 
                        0, InitialROPlaces, 
                        1, InitialActionList, 1, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[2][2]={ 
    {0,0}, {1,0}
  };
  for(int n=0;n<2;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[2][2]={ 
    {0,0}, {2,0}
  };
  for(int n=0;n<2;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<1;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void InitializerSAN::CustomInitialization() {

}
InitializerSAN::~InitializerSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void InitializerSAN::assignPlacesToActivitiesInst(){
  IA_Create_Clients_MW_Servers.Start = (Place*) LocalStateVariables[0];
  IA_Create_Clients_MW_Servers.Client_Trans_IDs = (Place*) LocalStateVariables[2];
  IA_Create_Clients_MW_Servers.Start_Clients_and_Servers = (Place*) LocalStateVariables[1];
}
void InitializerSAN::assignPlacesToActivitiesTimed(){
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================IA_Create_Clients_MW_ServersActivity========================*/


InitializerSAN::IA_Create_Clients_MW_ServersActivity::IA_Create_Clients_MW_ServersActivity(){
  ActivityInitialize("IA_Create_Clients_MW_Servers",0,Instantaneous , RaceEnabled, 2,2, false);
}

void InitializerSAN::IA_Create_Clients_MW_ServersActivity::LinkVariables(){
  Start->Register(&Start_Mobius_Mark);
  Client_Trans_IDs->Register(&Client_Trans_IDs_Mobius_Mark);
  Start_Clients_and_Servers->Register(&Start_Clients_and_Servers_Mobius_Mark);
}

bool InitializerSAN::IA_Create_Clients_MW_ServersActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((Start->Mark()==1)&&(Client_Trans_IDs->Mark()==0)));
  return NewEnabled;
}

double InitializerSAN::IA_Create_Clients_MW_ServersActivity::Weight(){ 
  return 1;
}

bool InitializerSAN::IA_Create_Clients_MW_ServersActivity::ReactivationPredicate(){ 
  return false;
}

bool InitializerSAN::IA_Create_Clients_MW_ServersActivity::ReactivationFunction(){ 
  return false;
}

double InitializerSAN::IA_Create_Clients_MW_ServersActivity::SampleDistribution(){
  return 0;
}

double* InitializerSAN::IA_Create_Clients_MW_ServersActivity::ReturnDistributionParameters(){
    return NULL;
}

int InitializerSAN::IA_Create_Clients_MW_ServersActivity::Rank(){
  return 1;
}

BaseActionClass* InitializerSAN::IA_Create_Clients_MW_ServersActivity::Fire(){
  /* Call External Method to create Clients, Middleware and Server objects */
Initialize_Clients_and_Servers();

/* Set the places to indicate that initialization has been successful */
Start->Mark()=0;
Start_Clients_and_Servers->Mark()=1;

if(GV_debug_flag==22)
{
     cerr << "The non-trivial part of the simulation is about to begin!!!\n\n" << endl;
}

  return this;
}

