#ifndef Client_ServerRJ__Rep_Client_DivSQL_H_
#define Client_ServerRJ__Rep_Client_DivSQL_H_
#include "udf/DIDERO_PC.h"
#include <math.h>
#include "Cpp/Composer/Rep.h"
#include "Cpp/Composer/AllStateVariableTypes.h"

//Submodel header files
#include "Composed/Client_Server/Client_ServerRJ__Client_DivSQL.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"
extern short GV_debug_flag;
extern short GV_Number_of_Clients_and_Trans;
extern int GV_Efficient_Oper_Capacity_Server_1;
extern int GV_Efficient_Oper_Capacity_Server_2;
extern double GV_ExpScaling_LowerBound;

class Client_ServerRJ__Rep_Client_DivSQL: public Rep {
 public:
  Client_ServerRJ__Client_DivSQL ** InstanceArray;

  Client_ServerRJ__Rep_Client_DivSQL();
  ~Client_ServerRJ__Rep_Client_DivSQL();

  // Declare new variables
  Place * Begin_Edge_1;
  Place * Begin_Edge_2;
  Place * Init_Blocking_Ptrs;
  Place * Mutex_granted;
  Place * Mutex_pool;
  Place * Number_of_Clients;
  Place * Oper_1;
  Place * Oper_2;
  Place * ReacPulse_2_Server_1;
  Place * ReacPulse_2_Server_2;
  Place * Server_1_enabled;
  Place * Server_2_enabled;
  Place * Start_Client_Servers;
};

#endif
