if(GV_debug_flag==6)
{
     std::cerr << "DIDERO_PC:TransactionSAN_1: Transaction " << Trans_ID->Mark() << " has been unblocked!!!!" << std::endl;
}

    Blocked->Mark() = 0;
    Place_Unblocking->Mark() = 0;
    
    /* If this transaction should be aborted then return control to the client to 
    acknowledge the abort of this transaction. Otherwise, re-attempt to execute the 
    previously blocked operation 
    */

    if(Server_1->get_Abort(Trans_ID->Mark()))
    {  
       /* If the counterpart transaction has already been evaluated then indicate to the MW that 
          an Abort of both transactions should be carried out ultimately*/
       if(Exec_Oper_on_both_Servers[Trans_ID->Mark()-1])
       {
            if(GV_debug_flag==6)
            {
                std::cerr << "DIDERO_PC:TransactionSAN_1: The counterpart of Transaction " << Trans_ID->Mark() << " has induced both Transactions to ABORT!!!!" << std::endl;
            }

             /* This transaction should cause it and its counterpart on the server to be aborted */
             Oper_results[Trans_ID->Mark()-1] = std::string("");
             ClientObjects[Trans_ID->Mark()-1]->set_Oper_Exec_Status(std::string("Servers Disagree"));
             Exec_Oper_on_both_Servers[Trans_ID->Mark()-1] = false; 	

       }else
       {
           /* This is the first transaction to "complete" its operation, despite this "completion"
              being an Abort. This should be indicated for the counterpart transaction's benefit
              when that transaction eventually completes its operation */
           
            if(GV_debug_flag==6)
            {
                std::cerr << "DIDERO_PC:TransactionSAN_1: This Transaction " << Trans_ID->Mark() << " will induce both it, and its countrerpart Transactions, to ABORT!!!!" << std::endl;
            }

           Exec_Oper_on_both_Servers[Trans_ID->Mark()-1] = true;
           Oper_results[Trans_ID->Mark()-1] = std::string("Abort");
           //ClientObjects[Trans_ID->Mark()-1]->set_Oper_Exec_Status(std::string("Servers Disagree"));
       }
       
       Operation_Executed_Server_1->Mark()=1;
       if(GV_debug_flag==6)
       {
          std::cerr << "DIDERO_PC:TransactionSAN_1: Transaction " << Trans_ID->Mark() << " is to be aborted!!!!" << std::endl;
       }       

    }else
    {
       if(GV_debug_flag==6)
       {
          std::cerr << "DIDERO_PC:TransactionSAN_1: Transaction " << Trans_ID->Mark() << " is to have its last operation re-executed!!!!" << std::endl;
       }      
       Request_Operation_Server->Mark() = 1;
    }
 
       Server_1->set_Blocked(Trans_ID->Mark(),false);