#include "Composed/Client_Server/Client_ServerRJ__Client_DivSQL.h"
char * Client_ServerRJ__Client_DivSQL__SharedNames[] = {"Begin_Edge_1", "Begin_Edge_2", "Begin_Success_1", "Begin_Success_2", "Client_ID", "Execute_Transaction_MW_Client", "Execute_Transaction_MW_Server_1", "Execute_Transaction_MW_Server_2", "Init_Blocking_Ptrs", "Mutex_granted", "Mutex_pool", "Number_of_Clients", "Oper_1", "Oper_2", "Operation_Executed_MW_Client", "Operation_Executed_MW_Server_1", "Operation_Executed_MW_Server_2", "ReacPulse_2_Server_1", "ReacPulse_2_Server_2", "Request_Operation_MW_Client", "Request_Operation_MW_Server_1", "Request_Operation_MW_Server_2", "Server_1_enabled", "Server_2_enabled", "Start_Client_Servers"};

Client_ServerRJ__Client_DivSQL::Client_ServerRJ__Client_DivSQL():Join("Client_DivSQL", 4, 25,Client_ServerRJ__Client_DivSQL__SharedNames) {
  TransactionSAN_2 = new TransactionSAN_2SAN();
  ModelArray[0] = (BaseModelClass*) TransactionSAN_2;
  ModelArray[0]->DefineName("TransactionSAN_2");
  ClientSAN = new ClientSANSAN();
  ModelArray[1] = (BaseModelClass*) ClientSAN;
  ModelArray[1]->DefineName("ClientSAN");
  Middleware_SAN = new Middleware_SANSAN();
  ModelArray[2] = (BaseModelClass*) Middleware_SAN;
  ModelArray[2]->DefineName("Middleware_SAN");
  TransactionSAN_1 = new TransactionSAN_1SAN();
  ModelArray[3] = (BaseModelClass*) TransactionSAN_1;
  ModelArray[3]->DefineName("TransactionSAN_1");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    Begin_Edge_1 = new Place("Begin_Edge_1");
    addSharedPtr(Begin_Edge_1, "Begin_Edge_1" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      Begin_Edge_1->ShareWith(TransactionSAN_1->Begin_Edge);
      addSharingInfo(TransactionSAN_1->Begin_Edge, Begin_Edge_1, TransactionSAN_1);
    }

    //Shared variable 1
    Begin_Edge_2 = new Place("Begin_Edge_2");
    addSharedPtr(Begin_Edge_2, "Begin_Edge_2" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      Begin_Edge_2->ShareWith(TransactionSAN_2->Begin_Edge);
      addSharingInfo(TransactionSAN_2->Begin_Edge, Begin_Edge_2, TransactionSAN_2);
    }

    //Shared variable 2
    Begin_Success_1 = new Place("Begin_Success_1");
    addSharedPtr(Begin_Success_1, "Begin_Success_1" );
    if (Middleware_SAN->NumStateVariables > 0) {
      Begin_Success_1->ShareWith(Middleware_SAN->Begin_called_1);
      addSharingInfo(Middleware_SAN->Begin_called_1, Begin_Success_1, Middleware_SAN);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Begin_Success_1->ShareWith(TransactionSAN_1->Begin_Success);
      addSharingInfo(TransactionSAN_1->Begin_Success, Begin_Success_1, TransactionSAN_1);
    }

    //Shared variable 3
    Begin_Success_2 = new Place("Begin_Success_2");
    addSharedPtr(Begin_Success_2, "Begin_Success_2" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      Begin_Success_2->ShareWith(TransactionSAN_2->Begin_Success);
      addSharingInfo(TransactionSAN_2->Begin_Success, Begin_Success_2, TransactionSAN_2);
    }
    if (Middleware_SAN->NumStateVariables > 0) {
      Begin_Success_2->ShareWith(Middleware_SAN->Begin_called_2);
      addSharingInfo(Middleware_SAN->Begin_called_2, Begin_Success_2, Middleware_SAN);
    }

    //Shared variable 4
    Client_ID = new Place("Client_ID");
    addSharedPtr(Client_ID, "Client_ID" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      Client_ID->ShareWith(TransactionSAN_2->Trans_ID);
      addSharingInfo(TransactionSAN_2->Trans_ID, Client_ID, TransactionSAN_2);
    }
    if (ClientSAN->NumStateVariables > 0) {
      Client_ID->ShareWith(ClientSAN->Client_ID);
      addSharingInfo(ClientSAN->Client_ID, Client_ID, ClientSAN);
    }
    if (Middleware_SAN->NumStateVariables > 0) {
      Client_ID->ShareWith(Middleware_SAN->Middleware_ID);
      addSharingInfo(Middleware_SAN->Middleware_ID, Client_ID, Middleware_SAN);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Client_ID->ShareWith(TransactionSAN_1->Trans_ID);
      addSharingInfo(TransactionSAN_1->Trans_ID, Client_ID, TransactionSAN_1);
    }

    //Shared variable 5
    Execute_Transaction_MW_Client = new Place("Execute_Transaction_MW_Client");
    addSharedPtr(Execute_Transaction_MW_Client, "Execute_Transaction_MW_Client" );
    if (ClientSAN->NumStateVariables > 0) {
      Execute_Transaction_MW_Client->ShareWith(ClientSAN->Execute_Transaction);
      addSharingInfo(ClientSAN->Execute_Transaction, Execute_Transaction_MW_Client, ClientSAN);
    }
    if (Middleware_SAN->NumStateVariables > 0) {
      Execute_Transaction_MW_Client->ShareWith(Middleware_SAN->Execute_Transaction_current);
      addSharingInfo(Middleware_SAN->Execute_Transaction_current, Execute_Transaction_MW_Client, Middleware_SAN);
    }

    //Shared variable 6
    Execute_Transaction_MW_Server_1 = new Place("Execute_Transaction_MW_Server_1");
    addSharedPtr(Execute_Transaction_MW_Server_1, "Execute_Transaction_MW_Server_1" );
    if (Middleware_SAN->NumStateVariables > 0) {
      Execute_Transaction_MW_Server_1->ShareWith(Middleware_SAN->Execute_Transaction_1);
      addSharingInfo(Middleware_SAN->Execute_Transaction_1, Execute_Transaction_MW_Server_1, Middleware_SAN);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Execute_Transaction_MW_Server_1->ShareWith(TransactionSAN_1->Execute_Transaction);
      addSharingInfo(TransactionSAN_1->Execute_Transaction, Execute_Transaction_MW_Server_1, TransactionSAN_1);
    }

    //Shared variable 7
    Execute_Transaction_MW_Server_2 = new Place("Execute_Transaction_MW_Server_2");
    addSharedPtr(Execute_Transaction_MW_Server_2, "Execute_Transaction_MW_Server_2" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      Execute_Transaction_MW_Server_2->ShareWith(TransactionSAN_2->Execute_Transaction);
      addSharingInfo(TransactionSAN_2->Execute_Transaction, Execute_Transaction_MW_Server_2, TransactionSAN_2);
    }
    if (Middleware_SAN->NumStateVariables > 0) {
      Execute_Transaction_MW_Server_2->ShareWith(Middleware_SAN->Execute_Transaction_2);
      addSharingInfo(Middleware_SAN->Execute_Transaction_2, Execute_Transaction_MW_Server_2, Middleware_SAN);
    }

    //Shared variable 8
    Init_Blocking_Ptrs = new Place("Init_Blocking_Ptrs");
    addSharedPtr(Init_Blocking_Ptrs, "Init_Blocking_Ptrs" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      Init_Blocking_Ptrs->ShareWith(TransactionSAN_1->Init_Blocking_Ptrs);
      addSharingInfo(TransactionSAN_1->Init_Blocking_Ptrs, Init_Blocking_Ptrs, TransactionSAN_1);
    }

    //Shared variable 9
    Mutex_granted = new Place("Mutex_granted");
    addSharedPtr(Mutex_granted, "Mutex_granted" );
    if (Middleware_SAN->NumStateVariables > 0) {
      Mutex_granted->ShareWith(Middleware_SAN->Mutex_granted);
      addSharingInfo(Middleware_SAN->Mutex_granted, Mutex_granted, Middleware_SAN);
    }

    //Shared variable 10
    Mutex_pool = new Place("Mutex_pool");
    addSharedPtr(Mutex_pool, "Mutex_pool" );
    if (Middleware_SAN->NumStateVariables > 0) {
      Mutex_pool->ShareWith(Middleware_SAN->Mutex_pool);
      addSharingInfo(Middleware_SAN->Mutex_pool, Mutex_pool, Middleware_SAN);
    }

    //Shared variable 11
    Number_of_Clients = new Place("Number_of_Clients");
    addSharedPtr(Number_of_Clients, "Number_of_Clients" );
    if (ClientSAN->NumStateVariables > 0) {
      Number_of_Clients->ShareWith(ClientSAN->Number_of_Clients);
      addSharingInfo(ClientSAN->Number_of_Clients, Number_of_Clients, ClientSAN);
    }

    //Shared variable 12
    Oper_1 = new Place("Oper_1");
    addSharedPtr(Oper_1, "Oper_1" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      Oper_1->ShareWith(TransactionSAN_1->Oper);
      addSharingInfo(TransactionSAN_1->Oper, Oper_1, TransactionSAN_1);
    }

    //Shared variable 13
    Oper_2 = new Place("Oper_2");
    addSharedPtr(Oper_2, "Oper_2" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      Oper_2->ShareWith(TransactionSAN_2->Oper);
      addSharingInfo(TransactionSAN_2->Oper, Oper_2, TransactionSAN_2);
    }

    //Shared variable 14
    Operation_Executed_MW_Client = new Place("Operation_Executed_MW_Client");
    addSharedPtr(Operation_Executed_MW_Client, "Operation_Executed_MW_Client" );
    if (ClientSAN->NumStateVariables > 0) {
      Operation_Executed_MW_Client->ShareWith(ClientSAN->Next_Operation_Details_1);
      addSharingInfo(ClientSAN->Next_Operation_Details_1, Operation_Executed_MW_Client, ClientSAN);
    }
    if (Middleware_SAN->NumStateVariables > 0) {
      Operation_Executed_MW_Client->ShareWith(Middleware_SAN->Operation_Executed_current);
      addSharingInfo(Middleware_SAN->Operation_Executed_current, Operation_Executed_MW_Client, Middleware_SAN);
    }

    //Shared variable 15
    Operation_Executed_MW_Server_1 = new Place("Operation_Executed_MW_Server_1");
    addSharedPtr(Operation_Executed_MW_Server_1, "Operation_Executed_MW_Server_1" );
    if (Middleware_SAN->NumStateVariables > 0) {
      Operation_Executed_MW_Server_1->ShareWith(Middleware_SAN->Operation_Executed_Server_1);
      addSharingInfo(Middleware_SAN->Operation_Executed_Server_1, Operation_Executed_MW_Server_1, Middleware_SAN);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Operation_Executed_MW_Server_1->ShareWith(TransactionSAN_1->Operation_Executed_Server_1);
      addSharingInfo(TransactionSAN_1->Operation_Executed_Server_1, Operation_Executed_MW_Server_1, TransactionSAN_1);
    }

    //Shared variable 16
    Operation_Executed_MW_Server_2 = new Place("Operation_Executed_MW_Server_2");
    addSharedPtr(Operation_Executed_MW_Server_2, "Operation_Executed_MW_Server_2" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      Operation_Executed_MW_Server_2->ShareWith(TransactionSAN_2->Operation_Executed_Server_2);
      addSharingInfo(TransactionSAN_2->Operation_Executed_Server_2, Operation_Executed_MW_Server_2, TransactionSAN_2);
    }
    if (Middleware_SAN->NumStateVariables > 0) {
      Operation_Executed_MW_Server_2->ShareWith(Middleware_SAN->Operation_Executed_Server_2);
      addSharingInfo(Middleware_SAN->Operation_Executed_Server_2, Operation_Executed_MW_Server_2, Middleware_SAN);
    }

    //Shared variable 17
    ReacPulse_2_Server_1 = new Place("ReacPulse_2_Server_1");
    addSharedPtr(ReacPulse_2_Server_1, "ReacPulse_2_Server_1" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      ReacPulse_2_Server_1->ShareWith(TransactionSAN_1->ReacPulse_2);
      addSharingInfo(TransactionSAN_1->ReacPulse_2, ReacPulse_2_Server_1, TransactionSAN_1);
    }

    //Shared variable 18
    ReacPulse_2_Server_2 = new Place("ReacPulse_2_Server_2");
    addSharedPtr(ReacPulse_2_Server_2, "ReacPulse_2_Server_2" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      ReacPulse_2_Server_2->ShareWith(TransactionSAN_2->ReacPulse_2);
      addSharingInfo(TransactionSAN_2->ReacPulse_2, ReacPulse_2_Server_2, TransactionSAN_2);
    }

    //Shared variable 19
    Request_Operation_MW_Client = new Place("Request_Operation_MW_Client");
    addSharedPtr(Request_Operation_MW_Client, "Request_Operation_MW_Client" );
    if (ClientSAN->NumStateVariables > 0) {
      Request_Operation_MW_Client->ShareWith(ClientSAN->Request_Operation_Client_1);
      addSharingInfo(ClientSAN->Request_Operation_Client_1, Request_Operation_MW_Client, ClientSAN);
    }
    if (Middleware_SAN->NumStateVariables > 0) {
      Request_Operation_MW_Client->ShareWith(Middleware_SAN->Request_Operation_Server_current);
      addSharingInfo(Middleware_SAN->Request_Operation_Server_current, Request_Operation_MW_Client, Middleware_SAN);
    }

    //Shared variable 20
    Request_Operation_MW_Server_1 = new Place("Request_Operation_MW_Server_1");
    addSharedPtr(Request_Operation_MW_Server_1, "Request_Operation_MW_Server_1" );
    if (Middleware_SAN->NumStateVariables > 0) {
      Request_Operation_MW_Server_1->ShareWith(Middleware_SAN->Request_Operation_Server_1);
      addSharingInfo(Middleware_SAN->Request_Operation_Server_1, Request_Operation_MW_Server_1, Middleware_SAN);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Request_Operation_MW_Server_1->ShareWith(TransactionSAN_1->Request_Operation_Server);
      addSharingInfo(TransactionSAN_1->Request_Operation_Server, Request_Operation_MW_Server_1, TransactionSAN_1);
    }

    //Shared variable 21
    Request_Operation_MW_Server_2 = new Place("Request_Operation_MW_Server_2");
    addSharedPtr(Request_Operation_MW_Server_2, "Request_Operation_MW_Server_2" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      Request_Operation_MW_Server_2->ShareWith(TransactionSAN_2->Request_Operation_Server);
      addSharingInfo(TransactionSAN_2->Request_Operation_Server, Request_Operation_MW_Server_2, TransactionSAN_2);
    }
    if (Middleware_SAN->NumStateVariables > 0) {
      Request_Operation_MW_Server_2->ShareWith(Middleware_SAN->Request_Operation_Server_2);
      addSharingInfo(Middleware_SAN->Request_Operation_Server_2, Request_Operation_MW_Server_2, Middleware_SAN);
    }

    //Shared variable 22
    Server_1_enabled = new Place("Server_1_enabled");
    addSharedPtr(Server_1_enabled, "Server_1_enabled" );
    if (Middleware_SAN->NumStateVariables > 0) {
      Server_1_enabled->ShareWith(Middleware_SAN->Server_1_enabled);
      addSharingInfo(Middleware_SAN->Server_1_enabled, Server_1_enabled, Middleware_SAN);
    }

    //Shared variable 23
    Server_2_enabled = new Place("Server_2_enabled");
    addSharedPtr(Server_2_enabled, "Server_2_enabled" );
    if (Middleware_SAN->NumStateVariables > 0) {
      Server_2_enabled->ShareWith(Middleware_SAN->Server_2_enabled);
      addSharingInfo(Middleware_SAN->Server_2_enabled, Server_2_enabled, Middleware_SAN);
    }

    //Shared variable 24
    Start_Client_Servers = new Place("Start_Client_Servers");
    addSharedPtr(Start_Client_Servers, "Start_Client_Servers" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      Start_Client_Servers->ShareWith(TransactionSAN_2->Start_Servers);
      addSharingInfo(TransactionSAN_2->Start_Servers, Start_Client_Servers, TransactionSAN_2);
    }
    if (ClientSAN->NumStateVariables > 0) {
      Start_Client_Servers->ShareWith(ClientSAN->Start_Clients);
      addSharingInfo(ClientSAN->Start_Clients, Start_Client_Servers, ClientSAN);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Start_Client_Servers->ShareWith(TransactionSAN_1->Start_Servers);
      addSharingInfo(TransactionSAN_1->Start_Servers, Start_Client_Servers, TransactionSAN_1);
    }

  }

  Setup();
}

Client_ServerRJ__Client_DivSQL::~Client_ServerRJ__Client_DivSQL() {
  if (!AllChildrenEmpty()) {
    delete Begin_Edge_1;
    delete Begin_Edge_2;
    delete Begin_Success_1;
    delete Begin_Success_2;
    delete Client_ID;
    delete Execute_Transaction_MW_Client;
    delete Execute_Transaction_MW_Server_1;
    delete Execute_Transaction_MW_Server_2;
    delete Init_Blocking_Ptrs;
    delete Mutex_granted;
    delete Mutex_pool;
    delete Number_of_Clients;
    delete Oper_1;
    delete Oper_2;
    delete Operation_Executed_MW_Client;
    delete Operation_Executed_MW_Server_1;
    delete Operation_Executed_MW_Server_2;
    delete ReacPulse_2_Server_1;
    delete ReacPulse_2_Server_2;
    delete Request_Operation_MW_Client;
    delete Request_Operation_MW_Server_1;
    delete Request_Operation_MW_Server_2;
    delete Server_1_enabled;
    delete Server_2_enabled;
    delete Start_Client_Servers;
  }
  delete TransactionSAN_2;
  delete ClientSAN;
  delete Middleware_SAN;
  delete TransactionSAN_1;
}
