#include "Composed/Client_Server/Client_ServerRJ__DivSQL.h"
char * Client_ServerRJ__DivSQL__SharedNames[] = {"All_Server_1_Trans_CommitSuccess_1", "All_Server_1_Trans_DivREPTrans1", "All_Server_2_Trans_CommitSuccess_1", "All_Server_2_Trans_DivREPTrans2", "Begin_Server_1", "Begin_Server_2", "Begin_Success_Server_1", "Begin_Success_Server_2", "DivSQL_ID", "End_Oper_Server_1", "End_Oper_Server_2", "Init_Blocking_Pointers", "Operation_Executed_Client", "Operation_Executed_ServerMW_1", "Operation_Executed_ServerMW_2", "Request_Operation_Client", "Request_Operation_ServerMW_1", "Request_Operation_ServerMW_2", "Start_Oper_Server_1", "Start_Oper_Server_2", "Start_Servers_MW", "Trans_Oper_Server_1", "Trans_Oper_Server_2"};

Client_ServerRJ__DivSQL::Client_ServerRJ__DivSQL():Join("DivSQL", 3, 23,Client_ServerRJ__DivSQL__SharedNames) {
  DivRep = new DivSQLSAN();
  ModelArray[0] = (BaseModelClass*) DivRep;
  ModelArray[0]->DefineName("DivRep");
  TransactionSAN_1 = new TransactionSAN_1SAN();
  ModelArray[1] = (BaseModelClass*) TransactionSAN_1;
  ModelArray[1]->DefineName("TransactionSAN_1");
  TransactionSAN_2 = new TransactionSAN_2SAN();
  ModelArray[2] = (BaseModelClass*) TransactionSAN_2;
  ModelArray[2]->DefineName("TransactionSAN_2");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    All_Server_1_Trans_CommitSuccess_1 = new Place("All_Server_1_Trans_CommitSuccess_1");
    addSharedPtr(All_Server_1_Trans_CommitSuccess_1, "All_Server_1_Trans_CommitSuccess_1" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      All_Server_1_Trans_CommitSuccess_1->ShareWith(TransactionSAN_1->All_Server_1_Trans_CommitSuccess);
      addSharingInfo(TransactionSAN_1->All_Server_1_Trans_CommitSuccess, All_Server_1_Trans_CommitSuccess_1, TransactionSAN_1);
    }

    //Shared variable 1
    All_Server_1_Trans_DivREPTrans1 = new Place("All_Server_1_Trans_DivREPTrans1");
    addSharedPtr(All_Server_1_Trans_DivREPTrans1, "All_Server_1_Trans_DivREPTrans1" );
    if (DivRep->NumStateVariables > 0) {
      All_Server_1_Trans_DivREPTrans1->ShareWith(DivRep->All_Server_1_Transactions);
      addSharingInfo(DivRep->All_Server_1_Transactions, All_Server_1_Trans_DivREPTrans1, DivRep);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      All_Server_1_Trans_DivREPTrans1->ShareWith(TransactionSAN_1->All_Server_1_Transactions);
      addSharingInfo(TransactionSAN_1->All_Server_1_Transactions, All_Server_1_Trans_DivREPTrans1, TransactionSAN_1);
    }

    //Shared variable 2
    All_Server_2_Trans_CommitSuccess_1 = new Place("All_Server_2_Trans_CommitSuccess_1");
    addSharedPtr(All_Server_2_Trans_CommitSuccess_1, "All_Server_2_Trans_CommitSuccess_1" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      All_Server_2_Trans_CommitSuccess_1->ShareWith(TransactionSAN_2->All_Server_2_Trans_CommitSuccess);
      addSharingInfo(TransactionSAN_2->All_Server_2_Trans_CommitSuccess, All_Server_2_Trans_CommitSuccess_1, TransactionSAN_2);
    }

    //Shared variable 3
    All_Server_2_Trans_DivREPTrans2 = new Place("All_Server_2_Trans_DivREPTrans2");
    addSharedPtr(All_Server_2_Trans_DivREPTrans2, "All_Server_2_Trans_DivREPTrans2" );
    if (DivRep->NumStateVariables > 0) {
      All_Server_2_Trans_DivREPTrans2->ShareWith(DivRep->All_Server_2_Transactions);
      addSharingInfo(DivRep->All_Server_2_Transactions, All_Server_2_Trans_DivREPTrans2, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      All_Server_2_Trans_DivREPTrans2->ShareWith(TransactionSAN_2->All_Server_2_Transactions);
      addSharingInfo(TransactionSAN_2->All_Server_2_Transactions, All_Server_2_Trans_DivREPTrans2, TransactionSAN_2);
    }

    //Shared variable 4
    Begin_Server_1 = new Place("Begin_Server_1");
    addSharedPtr(Begin_Server_1, "Begin_Server_1" );
    if (DivRep->NumStateVariables > 0) {
      Begin_Server_1->ShareWith(DivRep->Begin_Server_1);
      addSharingInfo(DivRep->Begin_Server_1, Begin_Server_1, DivRep);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Begin_Server_1->ShareWith(TransactionSAN_1->Begin_Server_1);
      addSharingInfo(TransactionSAN_1->Begin_Server_1, Begin_Server_1, TransactionSAN_1);
    }

    //Shared variable 5
    Begin_Server_2 = new Place("Begin_Server_2");
    addSharedPtr(Begin_Server_2, "Begin_Server_2" );
    if (DivRep->NumStateVariables > 0) {
      Begin_Server_2->ShareWith(DivRep->Begin_Server_2);
      addSharingInfo(DivRep->Begin_Server_2, Begin_Server_2, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      Begin_Server_2->ShareWith(TransactionSAN_2->Begin_Server_2);
      addSharingInfo(TransactionSAN_2->Begin_Server_2, Begin_Server_2, TransactionSAN_2);
    }

    //Shared variable 6
    Begin_Success_Server_1 = new Place("Begin_Success_Server_1");
    addSharedPtr(Begin_Success_Server_1, "Begin_Success_Server_1" );
    if (DivRep->NumStateVariables > 0) {
      Begin_Success_Server_1->ShareWith(DivRep->Begin_Success_Server_1);
      addSharingInfo(DivRep->Begin_Success_Server_1, Begin_Success_Server_1, DivRep);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Begin_Success_Server_1->ShareWith(TransactionSAN_1->Begin_Success_Server_1);
      addSharingInfo(TransactionSAN_1->Begin_Success_Server_1, Begin_Success_Server_1, TransactionSAN_1);
    }

    //Shared variable 7
    Begin_Success_Server_2 = new Place("Begin_Success_Server_2");
    addSharedPtr(Begin_Success_Server_2, "Begin_Success_Server_2" );
    if (DivRep->NumStateVariables > 0) {
      Begin_Success_Server_2->ShareWith(DivRep->Begin_Success_Server_2);
      addSharingInfo(DivRep->Begin_Success_Server_2, Begin_Success_Server_2, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      Begin_Success_Server_2->ShareWith(TransactionSAN_2->Begin_Success_Server_2);
      addSharingInfo(TransactionSAN_2->Begin_Success_Server_2, Begin_Success_Server_2, TransactionSAN_2);
    }

    //Shared variable 8
    DivSQL_ID = new Place("DivSQL_ID");
    addSharedPtr(DivSQL_ID, "DivSQL_ID" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      DivSQL_ID->ShareWith(TransactionSAN_1->Trans_ID);
      addSharingInfo(TransactionSAN_1->Trans_ID, DivSQL_ID, TransactionSAN_1);
    }
    if (DivRep->NumStateVariables > 0) {
      DivSQL_ID->ShareWith(DivRep->MW_ID);
      addSharingInfo(DivRep->MW_ID, DivSQL_ID, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      DivSQL_ID->ShareWith(TransactionSAN_2->Trans_ID);
      addSharingInfo(TransactionSAN_2->Trans_ID, DivSQL_ID, TransactionSAN_2);
    }

    //Shared variable 9
    End_Oper_Server_1 = new Place("End_Oper_Server_1");
    addSharedPtr(End_Oper_Server_1, "End_Oper_Server_1" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      End_Oper_Server_1->ShareWith(TransactionSAN_1->End_Oper_Server_1);
      addSharingInfo(TransactionSAN_1->End_Oper_Server_1, End_Oper_Server_1, TransactionSAN_1);
    }

    //Shared variable 10
    End_Oper_Server_2 = new Place("End_Oper_Server_2");
    addSharedPtr(End_Oper_Server_2, "End_Oper_Server_2" );
    if (TransactionSAN_2->NumStateVariables > 0) {
      End_Oper_Server_2->ShareWith(TransactionSAN_2->End_Oper_Server_2);
      addSharingInfo(TransactionSAN_2->End_Oper_Server_2, End_Oper_Server_2, TransactionSAN_2);
    }

    //Shared variable 11
    Init_Blocking_Pointers = new Place("Init_Blocking_Pointers");
    addSharedPtr(Init_Blocking_Pointers, "Init_Blocking_Pointers" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      Init_Blocking_Pointers->ShareWith(TransactionSAN_1->Init_Blocking_Pointers);
      addSharingInfo(TransactionSAN_1->Init_Blocking_Pointers, Init_Blocking_Pointers, TransactionSAN_1);
    }

    //Shared variable 12
    Operation_Executed_Client = new Place("Operation_Executed_Client");
    addSharedPtr(Operation_Executed_Client, "Operation_Executed_Client" );
    if (DivRep->NumStateVariables > 0) {
      Operation_Executed_Client->ShareWith(DivRep->Operation_Executed_Client);
      addSharingInfo(DivRep->Operation_Executed_Client, Operation_Executed_Client, DivRep);
    }

    //Shared variable 13
    Operation_Executed_ServerMW_1 = new Place("Operation_Executed_ServerMW_1");
    addSharedPtr(Operation_Executed_ServerMW_1, "Operation_Executed_ServerMW_1" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      Operation_Executed_ServerMW_1->ShareWith(TransactionSAN_1->Operation_Executed_Server_1);
      addSharingInfo(TransactionSAN_1->Operation_Executed_Server_1, Operation_Executed_ServerMW_1, TransactionSAN_1);
    }
    if (DivRep->NumStateVariables > 0) {
      Operation_Executed_ServerMW_1->ShareWith(DivRep->Operation_Executed_Server_1);
      addSharingInfo(DivRep->Operation_Executed_Server_1, Operation_Executed_ServerMW_1, DivRep);
    }

    //Shared variable 14
    Operation_Executed_ServerMW_2 = new Place("Operation_Executed_ServerMW_2");
    addSharedPtr(Operation_Executed_ServerMW_2, "Operation_Executed_ServerMW_2" );
    if (DivRep->NumStateVariables > 0) {
      Operation_Executed_ServerMW_2->ShareWith(DivRep->Operation_Executed_Server_2);
      addSharingInfo(DivRep->Operation_Executed_Server_2, Operation_Executed_ServerMW_2, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      Operation_Executed_ServerMW_2->ShareWith(TransactionSAN_2->Operation_Executed_Server_2);
      addSharingInfo(TransactionSAN_2->Operation_Executed_Server_2, Operation_Executed_ServerMW_2, TransactionSAN_2);
    }

    //Shared variable 15
    Request_Operation_Client = new Place("Request_Operation_Client");
    addSharedPtr(Request_Operation_Client, "Request_Operation_Client" );
    if (DivRep->NumStateVariables > 0) {
      Request_Operation_Client->ShareWith(DivRep->Request_Operation_Client);
      addSharingInfo(DivRep->Request_Operation_Client, Request_Operation_Client, DivRep);
    }

    //Shared variable 16
    Request_Operation_ServerMW_1 = new Place("Request_Operation_ServerMW_1");
    addSharedPtr(Request_Operation_ServerMW_1, "Request_Operation_ServerMW_1" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      Request_Operation_ServerMW_1->ShareWith(TransactionSAN_1->Request_Operation_Server);
      addSharingInfo(TransactionSAN_1->Request_Operation_Server, Request_Operation_ServerMW_1, TransactionSAN_1);
    }
    if (DivRep->NumStateVariables > 0) {
      Request_Operation_ServerMW_1->ShareWith(DivRep->Request_Operation_Server_1);
      addSharingInfo(DivRep->Request_Operation_Server_1, Request_Operation_ServerMW_1, DivRep);
    }

    //Shared variable 17
    Request_Operation_ServerMW_2 = new Place("Request_Operation_ServerMW_2");
    addSharedPtr(Request_Operation_ServerMW_2, "Request_Operation_ServerMW_2" );
    if (DivRep->NumStateVariables > 0) {
      Request_Operation_ServerMW_2->ShareWith(DivRep->Request_Operation_Server_2);
      addSharingInfo(DivRep->Request_Operation_Server_2, Request_Operation_ServerMW_2, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      Request_Operation_ServerMW_2->ShareWith(TransactionSAN_2->Request_Operation_Server);
      addSharingInfo(TransactionSAN_2->Request_Operation_Server, Request_Operation_ServerMW_2, TransactionSAN_2);
    }

    //Shared variable 18
    Start_Oper_Server_1 = new Place("Start_Oper_Server_1");
    addSharedPtr(Start_Oper_Server_1, "Start_Oper_Server_1" );
    if (DivRep->NumStateVariables > 0) {
      Start_Oper_Server_1->ShareWith(DivRep->Start_Oper_Server_1);
      addSharingInfo(DivRep->Start_Oper_Server_1, Start_Oper_Server_1, DivRep);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Start_Oper_Server_1->ShareWith(TransactionSAN_1->Start_Oper_Server_1);
      addSharingInfo(TransactionSAN_1->Start_Oper_Server_1, Start_Oper_Server_1, TransactionSAN_1);
    }

    //Shared variable 19
    Start_Oper_Server_2 = new Place("Start_Oper_Server_2");
    addSharedPtr(Start_Oper_Server_2, "Start_Oper_Server_2" );
    if (DivRep->NumStateVariables > 0) {
      Start_Oper_Server_2->ShareWith(DivRep->Start_Oper_Server_2);
      addSharingInfo(DivRep->Start_Oper_Server_2, Start_Oper_Server_2, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      Start_Oper_Server_2->ShareWith(TransactionSAN_2->Start_Oper_Server_2);
      addSharingInfo(TransactionSAN_2->Start_Oper_Server_2, Start_Oper_Server_2, TransactionSAN_2);
    }

    //Shared variable 20
    Start_Servers_MW = new Place("Start_Servers_MW");
    addSharedPtr(Start_Servers_MW, "Start_Servers_MW" );
    if (TransactionSAN_1->NumStateVariables > 0) {
      Start_Servers_MW->ShareWith(TransactionSAN_1->Start_Servers);
      addSharingInfo(TransactionSAN_1->Start_Servers, Start_Servers_MW, TransactionSAN_1);
    }
    if (DivRep->NumStateVariables > 0) {
      Start_Servers_MW->ShareWith(DivRep->Start_Clients_and_Servers);
      addSharingInfo(DivRep->Start_Clients_and_Servers, Start_Servers_MW, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      Start_Servers_MW->ShareWith(TransactionSAN_2->Start_Servers);
      addSharingInfo(TransactionSAN_2->Start_Servers, Start_Servers_MW, TransactionSAN_2);
    }

    //Shared variable 21
    Trans_Oper_Server_1 = new Place("Trans_Oper_Server_1");
    addSharedPtr(Trans_Oper_Server_1, "Trans_Oper_Server_1" );
    if (DivRep->NumStateVariables > 0) {
      Trans_Oper_Server_1->ShareWith(DivRep->Trans_Oper_Server_1);
      addSharingInfo(DivRep->Trans_Oper_Server_1, Trans_Oper_Server_1, DivRep);
    }
    if (TransactionSAN_1->NumStateVariables > 0) {
      Trans_Oper_Server_1->ShareWith(TransactionSAN_1->Trans_Oper_Server_1);
      addSharingInfo(TransactionSAN_1->Trans_Oper_Server_1, Trans_Oper_Server_1, TransactionSAN_1);
    }

    //Shared variable 22
    Trans_Oper_Server_2 = new Place("Trans_Oper_Server_2");
    addSharedPtr(Trans_Oper_Server_2, "Trans_Oper_Server_2" );
    if (DivRep->NumStateVariables > 0) {
      Trans_Oper_Server_2->ShareWith(DivRep->Trans_Oper_Server_2);
      addSharingInfo(DivRep->Trans_Oper_Server_2, Trans_Oper_Server_2, DivRep);
    }
    if (TransactionSAN_2->NumStateVariables > 0) {
      Trans_Oper_Server_2->ShareWith(TransactionSAN_2->Trans_Oper_Server_2);
      addSharingInfo(TransactionSAN_2->Trans_Oper_Server_2, Trans_Oper_Server_2, TransactionSAN_2);
    }

  }

  Setup();
}

Client_ServerRJ__DivSQL::~Client_ServerRJ__DivSQL() {
  if (!AllChildrenEmpty()) {
    delete All_Server_1_Trans_CommitSuccess_1;
    delete All_Server_1_Trans_DivREPTrans1;
    delete All_Server_2_Trans_CommitSuccess_1;
    delete All_Server_2_Trans_DivREPTrans2;
    delete Begin_Server_1;
    delete Begin_Server_2;
    delete Begin_Success_Server_1;
    delete Begin_Success_Server_2;
    delete DivSQL_ID;
    delete End_Oper_Server_1;
    delete End_Oper_Server_2;
    delete Init_Blocking_Pointers;
    delete Operation_Executed_Client;
    delete Operation_Executed_ServerMW_1;
    delete Operation_Executed_ServerMW_2;
    delete Request_Operation_Client;
    delete Request_Operation_ServerMW_1;
    delete Request_Operation_ServerMW_2;
    delete Start_Oper_Server_1;
    delete Start_Oper_Server_2;
    delete Start_Servers_MW;
    delete Trans_Oper_Server_1;
    delete Trans_Oper_Server_2;
  }
  delete DivRep;
  delete TransactionSAN_1;
  delete TransactionSAN_2;
}
