#include "Composed/Client_Server/Client_ServerRJ__Rep_Client_DivSQL.h"
char * Client_ServerRJ__Rep_Client_DivSQL__SharedNames[] = {"Begin_Edge_1", "Begin_Edge_2", "Init_Blocking_Ptrs", "Mutex_granted", "Mutex_pool", "Number_of_Clients", "Oper_1", "Oper_2", "ReacPulse_2_Server_1", "ReacPulse_2_Server_2", "Server_1_enabled", "Server_2_enabled", "Start_Client_Servers"};

Client_ServerRJ__Rep_Client_DivSQL::Client_ServerRJ__Rep_Client_DivSQL():Rep("Rep_Client_DivSQL", GV_Number_of_Clients_and_Trans, 13, Client_ServerRJ__Rep_Client_DivSQL__SharedNames)
{
  InstanceArray = new Client_ServerRJ__Client_DivSQL * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new Client_ServerRJ__Client_DivSQL();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    Begin_Edge_1 = new Place("Begin_Edge_1");
    addSharedPtr(Begin_Edge_1, "Begin_Edge_1");
    Begin_Edge_1->ShareWith(InstanceArray[0]->Begin_Edge_1);

    Begin_Edge_2 = new Place("Begin_Edge_2");
    addSharedPtr(Begin_Edge_2, "Begin_Edge_2");
    Begin_Edge_2->ShareWith(InstanceArray[0]->Begin_Edge_2);

    Init_Blocking_Ptrs = new Place("Init_Blocking_Ptrs");
    addSharedPtr(Init_Blocking_Ptrs, "Init_Blocking_Ptrs");
    Init_Blocking_Ptrs->ShareWith(InstanceArray[0]->Init_Blocking_Ptrs);

    Mutex_granted = new Place("Mutex_granted");
    addSharedPtr(Mutex_granted, "Mutex_granted");
    Mutex_granted->ShareWith(InstanceArray[0]->Mutex_granted);

    Mutex_pool = new Place("Mutex_pool");
    addSharedPtr(Mutex_pool, "Mutex_pool");
    Mutex_pool->ShareWith(InstanceArray[0]->Mutex_pool);

    Number_of_Clients = new Place("Number_of_Clients");
    addSharedPtr(Number_of_Clients, "Number_of_Clients");
    Number_of_Clients->ShareWith(InstanceArray[0]->Number_of_Clients);

    Oper_1 = new Place("Oper_1");
    addSharedPtr(Oper_1, "Oper_1");
    Oper_1->ShareWith(InstanceArray[0]->Oper_1);

    Oper_2 = new Place("Oper_2");
    addSharedPtr(Oper_2, "Oper_2");
    Oper_2->ShareWith(InstanceArray[0]->Oper_2);

    ReacPulse_2_Server_1 = new Place("ReacPulse_2_Server_1");
    addSharedPtr(ReacPulse_2_Server_1, "ReacPulse_2_Server_1");
    ReacPulse_2_Server_1->ShareWith(InstanceArray[0]->ReacPulse_2_Server_1);

    ReacPulse_2_Server_2 = new Place("ReacPulse_2_Server_2");
    addSharedPtr(ReacPulse_2_Server_2, "ReacPulse_2_Server_2");
    ReacPulse_2_Server_2->ShareWith(InstanceArray[0]->ReacPulse_2_Server_2);

    Server_1_enabled = new Place("Server_1_enabled");
    addSharedPtr(Server_1_enabled, "Server_1_enabled");
    Server_1_enabled->ShareWith(InstanceArray[0]->Server_1_enabled);

    Server_2_enabled = new Place("Server_2_enabled");
    addSharedPtr(Server_2_enabled, "Server_2_enabled");
    Server_2_enabled->ShareWith(InstanceArray[0]->Server_2_enabled);

    Start_Client_Servers = new Place("Start_Client_Servers");
    addSharedPtr(Start_Client_Servers, "Start_Client_Servers");
    Start_Client_Servers->ShareWith(InstanceArray[0]->Start_Client_Servers);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Begin_Edge_1, Begin_Edge_1);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Begin_Edge_2, Begin_Edge_2);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Init_Blocking_Ptrs, Init_Blocking_Ptrs);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Mutex_granted, Mutex_granted);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Mutex_pool, Mutex_pool);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Number_of_Clients, Number_of_Clients);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Oper_1, Oper_1);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Oper_2, Oper_2);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->ReacPulse_2_Server_1, ReacPulse_2_Server_1);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->ReacPulse_2_Server_2, ReacPulse_2_Server_2);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Server_1_enabled, Server_1_enabled);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Server_2_enabled, Server_2_enabled);
    }
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->Start_Client_Servers, Start_Client_Servers);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->Begin_Edge_1->ShareWith(InstanceArray[counter]->Begin_Edge_1);
      InstanceArray[0]->Begin_Edge_2->ShareWith(InstanceArray[counter]->Begin_Edge_2);
      InstanceArray[0]->Init_Blocking_Ptrs->ShareWith(InstanceArray[counter]->Init_Blocking_Ptrs);
      InstanceArray[0]->Mutex_granted->ShareWith(InstanceArray[counter]->Mutex_granted);
      InstanceArray[0]->Mutex_pool->ShareWith(InstanceArray[counter]->Mutex_pool);
      InstanceArray[0]->Number_of_Clients->ShareWith(InstanceArray[counter]->Number_of_Clients);
      InstanceArray[0]->Oper_1->ShareWith(InstanceArray[counter]->Oper_1);
      InstanceArray[0]->Oper_2->ShareWith(InstanceArray[counter]->Oper_2);
      InstanceArray[0]->ReacPulse_2_Server_1->ShareWith(InstanceArray[counter]->ReacPulse_2_Server_1);
      InstanceArray[0]->ReacPulse_2_Server_2->ShareWith(InstanceArray[counter]->ReacPulse_2_Server_2);
      InstanceArray[0]->Server_1_enabled->ShareWith(InstanceArray[counter]->Server_1_enabled);
      InstanceArray[0]->Server_2_enabled->ShareWith(InstanceArray[counter]->Server_2_enabled);
      InstanceArray[0]->Start_Client_Servers->ShareWith(InstanceArray[counter]->Start_Client_Servers);
    }
  }
  Setup("Client_DivSQL");
}

Client_ServerRJ__Rep_Client_DivSQL::~Client_ServerRJ__Rep_Client_DivSQL() {
  if (NumModels == 0) return;
  delete Begin_Edge_1;
  delete Begin_Edge_2;
  delete Init_Blocking_Ptrs;
  delete Mutex_granted;
  delete Mutex_pool;
  delete Number_of_Clients;
  delete Oper_1;
  delete Oper_2;
  delete ReacPulse_2_Server_1;
  delete ReacPulse_2_Server_2;
  delete Server_1_enabled;
  delete Server_2_enabled;
  delete Start_Client_Servers;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

